diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/eht-frame-exchange-manager.h ns-3.40/src/wifi/model/eht/eht-frame-exchange-manager.h
--- ns-3.39/src/wifi/model/eht/eht-frame-exchange-manager.h	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/eht-frame-exchange-manager.h	2023-09-27 13:30:37.902840000 -0700
@@ -45,6 +45,7 @@
 
     void SetLinkId(uint8_t linkId) override;
     Ptr<WifiMpdu> CreateAliasIfNeeded(Ptr<WifiMpdu> mpdu) const override;
+    bool StartTransmission(Ptr<Txop> edca, uint16_t allowedWidth) override;
 
     /**
      * Send an EML Operating Mode Notification frame to the given station.
@@ -52,8 +53,7 @@
      * \param dest the MAC address of the receiver
      * \param frame the EML Operating Mode Notification frame to send
      */
-    void SendEmlOperatingModeNotification(const Mac48Address& dest,
-                                          const MgtEmlOperatingModeNotification& frame);
+    void SendEmlOmn(const Mac48Address& dest, const MgtEmlOmn& frame);
 
     /**
      * Get the RSSI (in dBm) of the most recent packet received from the station having
@@ -77,11 +77,29 @@
                                    uint16_t aid,
                                    const Mac48Address& address) const;
 
+    /**
+     * Notify that the given PHY will switch channel to operate on another EMLSR link
+     * after the given delay.
+     *
+     * \param phy the given PHY
+     * \param linkId the ID of the EMLSR link on which the given PHY is operating
+     * \param delay the delay after which the channel switch will be completed
+     */
+    void NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy, uint8_t linkId, Time delay);
+
   protected:
+    void DoDispose() override;
+    void RxStartIndication(WifiTxVector txVector, Time psduDuration) override;
     void ForwardPsduDown(Ptr<const WifiPsdu> psdu, WifiTxVector& txVector) override;
     void ForwardPsduMapDown(WifiConstPsduMap psduMap, WifiTxVector& txVector) override;
     void SendMuRts(const WifiTxParameters& txParams) override;
+    void TransmissionFailed() override;
     void NotifyChannelReleased(Ptr<Txop> txop) override;
+    void PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
+    void ReceiveMpdu(Ptr<const WifiMpdu> mpdu,
+                     RxSignalInfo rxSignalInfo,
+                     const WifiTxVector& txVector,
+                     bool inAmpdu) override;
 
     /**
      * This method is intended to be called when an AP MLD detects that an EMLSR client previously
@@ -94,6 +112,34 @@
      * \param delay the given delay
      */
     void EmlsrSwitchToListening(const Mac48Address& address, const Time& delay);
+
+  private:
+    /**
+     * Update the TXOP end timer when starting a frame transmission.
+     *
+     * \param txDuration the TX duration of the frame being transmitted
+     */
+    void UpdateTxopEndOnTxStart(Time txDuration);
+
+    /**
+     * Update the TXOP end timer when receiving a PHY-RXSTART.indication.
+     *
+     * \param psduDuration the TX duration of the PSDU being received
+     */
+    void UpdateTxopEndOnRxStartIndication(Time psduDuration);
+
+    /**
+     * Update the TXOP end timer when a frame reception ends.
+     */
+    void UpdateTxopEndOnRxEnd();
+
+    /**
+     * Take actions when a TXOP (of which we are not the holder) ends.
+     */
+    void TxopEnd();
+
+    EventId m_ongoingTxopEnd; //!< event indicating the possible end of the current TXOP (of which
+                              //!< we are not the holder)
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/eht-phy.cc ns-3.40/src/wifi/model/eht/eht-phy.cc
--- ns-3.39/src/wifi/model/eht/eht-phy.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/eht-phy.cc	2023-09-27 13:30:37.902840000 -0700
@@ -138,13 +138,15 @@
             txVector.GetChannelWidth(),
             txVector.GetRuAllocation(
                 m_wifiPhy ? m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20) : 0),
-            txVector.GetEhtPpduType());
+            txVector.GetEhtPpduType(),
+            txVector.IsSigBCompression(),
+            txVector.IsSigBCompression() ? txVector.GetHeMuUserInfoMap().size() : 0);
     }
     return HePhy::GetSigBSize(txVector);
 }
 
 Time
-EhtPhy::CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const
+EhtPhy::CalculateNonHeDurationForHeTb(const WifiTxVector& txVector) const
 {
     Time duration = GetDuration(WIFI_PPDU_FIELD_PREAMBLE, txVector) +
                     GetDuration(WIFI_PPDU_FIELD_NON_HT_HEADER, txVector) +
@@ -153,7 +155,7 @@
 }
 
 Time
-EhtPhy::CalculateNonOfdmaDurationForHeMu(const WifiTxVector& txVector) const
+EhtPhy::CalculateNonHeDurationForHeMu(const WifiTxVector& txVector) const
 {
     Time duration = GetDuration(WIFI_PPDU_FIELD_PREAMBLE, txVector) +
                     GetDuration(WIFI_PPDU_FIELD_NON_HT_HEADER, txVector) +
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/eht-phy.h ns-3.40/src/wifi/model/eht/eht-phy.h
--- ns-3.39/src/wifi/model/eht/eht-phy.h	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/eht-phy.h	2023-09-27 13:30:37.902840000 -0700
@@ -260,8 +260,8 @@
                                 PhyFieldRxStatus status,
                                 WifiPpduField field) override;
     WifiPhyRxfailureReason GetFailureReason(WifiPpduField field) const override;
-    Time CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const override;
-    Time CalculateNonOfdmaDurationForHeMu(const WifiTxVector& txVector) const override;
+    Time CalculateNonHeDurationForHeTb(const WifiTxVector& txVector) const override;
+    Time CalculateNonHeDurationForHeMu(const WifiTxVector& txVector) const override;
     uint32_t GetSigBSize(const WifiTxVector& txVector) const override;
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/eht-ppdu.cc ns-3.40/src/wifi/model/eht/eht-ppdu.cc
--- ns-3.39/src/wifi/model/eht/eht-ppdu.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/eht-ppdu.cc	2023-09-27 13:30:37.902840000 -0700
@@ -25,6 +25,8 @@
 #include "ns3/wifi-phy-operating-channel.h"
 #include "ns3/wifi-psdu.h"
 
+#include <numeric>
+
 namespace ns3
 {
 
@@ -135,7 +137,19 @@
             ruAllocation.has_value())
         {
             txVector.SetRuAllocation(ruAllocation.value(), p20Index);
-            SetHeMuUserInfos(txVector, ruAllocation.value(), ehtPhyHeader->m_contentChannels);
+            const auto isMuMimo = (ehtPhyHeader->m_ppduType == 2);
+            const auto muMimoUsers =
+                isMuMimo
+                    ? std::accumulate(ehtPhyHeader->m_contentChannels.cbegin(),
+                                      ehtPhyHeader->m_contentChannels.cend(),
+                                      0,
+                                      [](uint8_t prev, const auto& cc) { return prev + cc.size(); })
+                    : 0;
+            SetHeMuUserInfos(txVector,
+                             ruAllocation.value(),
+                             ehtPhyHeader->m_contentChannels,
+                             ehtPhyHeader->m_ppduType == 2,
+                             muMimoUsers);
         }
         if (ehtPhyHeader->m_ppduType == 1) // EHT SU
         {
@@ -159,13 +173,18 @@
 std::pair<std::size_t, std::size_t>
 EhtPpdu::GetNumRusPerEhtSigBContentChannel(uint16_t channelWidth,
                                            uint8_t ehtPpduType,
-                                           const RuAllocation& ruAllocation)
+                                           const RuAllocation& ruAllocation,
+                                           bool compression,
+                                           std::size_t numMuMimoUsers)
 {
     if (ehtPpduType == 1)
     {
         return {1, 0};
     }
-    return HePpdu::GetNumRusPerHeSigBContentChannel(channelWidth, ruAllocation);
+    return HePpdu::GetNumRusPerHeSigBContentChannel(channelWidth,
+                                                    ruAllocation,
+                                                    compression,
+                                                    numMuMimoUsers);
 }
 
 HePpdu::HeSigBContentChannels
@@ -183,22 +202,31 @@
 uint32_t
 EhtPpdu::GetEhtSigFieldSize(uint16_t channelWidth,
                             const RuAllocation& ruAllocation,
-                            uint8_t ehtPpduType)
+                            uint8_t ehtPpduType,
+                            bool compression,
+                            std::size_t numMuMimoUsers)
 {
     // FIXME: EHT-SIG is not implemented yet, hence this is a copy of HE-SIG-B
-    auto commonFieldSize = 4 /* CRC */ + 6 /* tail */;
-    if (channelWidth <= 40)
-    {
-        commonFieldSize += 8; // only one allocation subfield
-    }
-    else
+    uint32_t commonFieldSize = 0;
+    if (!compression)
     {
-        commonFieldSize +=
-            8 * (channelWidth / 40) /* one allocation field per 40 MHz */ + 1 /* center RU */;
+        commonFieldSize = 4 /* CRC */ + 6 /* tail */;
+        if (channelWidth <= 40)
+        {
+            commonFieldSize += 8; // only one allocation subfield
+        }
+        else
+        {
+            commonFieldSize +=
+                8 * (channelWidth / 40) /* one allocation field per 40 MHz */ + 1 /* center RU */;
+        }
     }
 
-    auto numRusPerContentChannel =
-        GetNumRusPerEhtSigBContentChannel(channelWidth, ehtPpduType, ruAllocation);
+    auto numRusPerContentChannel = GetNumRusPerEhtSigBContentChannel(channelWidth,
+                                                                     ehtPpduType,
+                                                                     ruAllocation,
+                                                                     compression,
+                                                                     numMuMimoUsers);
     auto maxNumRusPerContentChannel =
         std::max(numRusPerContentChannel.first, numRusPerContentChannel.second);
     auto maxNumUserBlockFields = maxNumRusPerContentChannel /
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/eht-ppdu.h ns-3.40/src/wifi/model/eht/eht-ppdu.h
--- ns-3.39/src/wifi/model/eht/eht-ppdu.h	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/eht-ppdu.h	2023-09-27 13:30:37.902840000 -0700
@@ -110,13 +110,16 @@
      * \param channelWidth the channel width occupied by the PPDU (in MHz)
      * \param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
      * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
-
+     * \param compression flag whether compression mode is used by the PPDU
+     * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
      * \return a pair containing the number of RUs in each EHT-SIG-B content channel (resp. 1 and 2)
      */
     static std::pair<std::size_t, std::size_t> GetNumRusPerEhtSigBContentChannel(
         uint16_t channelWidth,
         uint8_t ehtPpduType,
-        const std::vector<uint8_t>& ruAllocation);
+        const std::vector<uint8_t>& ruAllocation,
+        bool compression,
+        std::size_t numMuMimoUsers);
 
     /**
      * Get the EHT-SIG content channels for a given PPDU
@@ -134,11 +137,15 @@
      * \param channelWidth the channel width occupied by the PPDU (in MHz)
      * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
      * \param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
+     * \param compression flag whether compression mode is used by the PPDU
+     * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
      * \return field size in bytes
      */
     static uint32_t GetEhtSigFieldSize(uint16_t channelWidth,
                                        const std::vector<uint8_t>& ruAllocation,
-                                       uint8_t ehtPpduType);
+                                       uint8_t ehtPpduType,
+                                       bool compression,
+                                       std::size_t numMuMimoUsers);
 
   private:
     bool IsDlMu() const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/emlsr-manager.cc ns-3.40/src/wifi/model/eht/emlsr-manager.cc
--- ns-3.39/src/wifi/model/eht/emlsr-manager.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/emlsr-manager.cc	2023-09-27 13:30:37.902840000 -0700
@@ -27,6 +27,8 @@
 #include "ns3/attribute-container.h"
 #include "ns3/log.h"
 #include "ns3/wifi-mpdu.h"
+#include "ns3/wifi-net-device.h"
+#include "ns3/wifi-phy-state-helper.h"
 
 namespace ns3
 {
@@ -55,12 +57,31 @@
                           MakeTimeAccessor(&EmlsrManager::m_emlsrTransitionDelay),
                           MakeTimeChecker(MicroSeconds(0), MicroSeconds(256)))
             .AddAttribute(
+                "MainPhyId",
+                "The ID of the main PHY (position in the vector of PHYs held by "
+                "WifiNetDevice). This attribute cannot be set after initialization.",
+                UintegerValue(0),
+                MakeUintegerAccessor(&EmlsrManager::SetMainPhyId, &EmlsrManager::GetMainPhyId),
+                MakeUintegerChecker<uint8_t>())
+            .AddAttribute("AuxPhyChannelWidth",
+                          "The maximum channel width (MHz) supported by Aux PHYs",
+                          UintegerValue(20),
+                          MakeUintegerAccessor(&EmlsrManager::m_auxPhyMaxWidth),
+                          MakeUintegerChecker<uint16_t>(20, 160))
+            .AddAttribute(
                 "EmlsrLinkSet",
                 "IDs of the links on which EMLSR mode will be enabled. An empty set "
                 "indicates to disable EMLSR.",
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&EmlsrManager::SetEmlsrLinks),
-                MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()));
+                MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()))
+            .AddAttribute("ResetCamState",
+                          "Whether to reset the state of the ChannelAccessManager associated with "
+                          "the link on which the main PHY has just switched to.",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&EmlsrManager::SetCamStateReset,
+                                              &EmlsrManager::GetCamStateReset),
+                          MakeBooleanChecker());
     return tid;
 }
 
@@ -103,6 +124,32 @@
                                          MakeCallback(&EmlsrManager::TxDropped, this));
 }
 
+void
+EmlsrManager::SetMainPhyId(uint8_t mainPhyId)
+{
+    NS_LOG_FUNCTION(this << mainPhyId);
+    NS_ABORT_MSG_IF(IsInitialized(), "Cannot be called once this object has been initialized");
+    m_mainPhyId = mainPhyId;
+}
+
+uint8_t
+EmlsrManager::GetMainPhyId() const
+{
+    return m_mainPhyId;
+}
+
+void
+EmlsrManager::SetCamStateReset(bool enable)
+{
+    m_resetCamState = enable;
+}
+
+bool
+EmlsrManager::GetCamStateReset() const
+{
+    return m_resetCamState;
+}
+
 const std::set<uint8_t>&
 EmlsrManager::GetEmlsrLinks() const
 {
@@ -148,7 +195,7 @@
     if (GetStaMac() && GetStaMac()->IsAssociated() && GetTransitionTimeout() && m_nextEmlsrLinks)
     {
         // Request to enable EMLSR mode on the given links, provided that they have been setup
-        SendEmlOperatingModeNotification();
+        SendEmlOmn();
     }
 }
 
@@ -161,12 +208,17 @@
 
     DoNotifyMgtFrameReceived(mpdu, linkId);
 
-    if (hdr.IsAssocResp() && GetStaMac()->IsAssociated() && GetTransitionTimeout() &&
-        m_nextEmlsrLinks && !m_nextEmlsrLinks->empty())
+    if (hdr.IsAssocResp() && GetStaMac()->IsAssociated() && GetTransitionTimeout())
     {
-        // we just completed ML setup with an AP MLD that supports EMLSR and a non-empty
-        // set of EMLSR links have been configured, hence enable EMLSR mode on those links
-        SendEmlOperatingModeNotification();
+        // we just completed ML setup with an AP MLD that supports EMLSR
+        ComputeOperatingChannels();
+
+        if (m_nextEmlsrLinks && !m_nextEmlsrLinks->empty())
+        {
+            // a non-empty set of EMLSR links have been configured, hence enable EMLSR mode
+            // on those links
+            SendEmlOmn();
+        }
     }
 
     if (hdr.IsAction() && hdr.GetAddr2() == m_staMac->GetBssid(linkId))
@@ -188,15 +240,152 @@
 }
 
 void
-EmlsrManager::SendEmlOperatingModeNotification()
+EmlsrManager::NotifyIcfReceived(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << linkId);
 
-    NS_ABORT_MSG_IF(!m_emlsrTransitionTimeout,
-                    "AP did not advertise a Transition Timeout, cannot send EML notification");
-    NS_ASSERT_MSG(m_nextEmlsrLinks, "Need to set EMLSR links before calling this method");
+    NS_ASSERT(m_staMac->IsEmlsrLink(linkId));
+
+    // block transmissions and suspend medium access on all other EMLSR links
+    for (auto id : m_staMac->GetLinkIds())
+    {
+        if (id != linkId && m_staMac->IsEmlsrLink(id))
+        {
+            m_staMac->BlockTxOnLink(id, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
+            m_staMac->GetChannelAccessManager(id)->NotifyStartUsingOtherEmlsrLink();
+        }
+    }
+
+    auto mainPhy = m_staMac->GetDevice()->GetPhy(m_mainPhyId);
+    auto auxPhy = m_staMac->GetWifiPhy(linkId);
+
+    if (m_staMac->GetWifiPhy(linkId) == mainPhy)
+    {
+        // nothing to do, we received an ICF from the main PHY
+        return;
+    }
+
+    SwitchMainPhy(linkId, true); // channel switch should occur instantaneously
+
+    // aux PHY received the ICF but main PHY will send the response
+    auto uid = auxPhy->GetPreviouslyRxPpduUid();
+    mainPhy->SetPreviouslyRxPpduUid(uid);
+}
+
+void
+EmlsrManager::NotifyUlTxopStart(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+
+    if (!m_staMac->IsEmlsrLink(linkId))
+    {
+        NS_LOG_DEBUG("EMLSR is not enabled on link " << +linkId);
+        return;
+    }
+
+    // block transmissions and suspend medium access on all other EMLSR links
+    for (auto id : m_staMac->GetLinkIds())
+    {
+        if (id != linkId && m_staMac->IsEmlsrLink(id))
+        {
+            m_staMac->BlockTxOnLink(id, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
+            m_staMac->GetChannelAccessManager(id)->NotifyStartUsingOtherEmlsrLink();
+        }
+    }
+
+    // if this TXOP is being started by an aux PHY, wait until the end of RTS transmission and
+    // then have the main PHY (instantaneously) take over the TXOP on this link. We may start the
+    // channel switch now and use the channel switch delay configured for the main PHY, but then
+    // we would have no guarantees that the channel switch is completed in RTS TX time plus SIFS.
+    if (m_staMac->GetLinkForPhy(m_mainPhyId) != linkId)
+    {
+        auto stateHelper = m_staMac->GetWifiPhy(linkId)->GetState();
+        NS_ASSERT(stateHelper);
+        NS_ASSERT_MSG(stateHelper->GetState() == TX,
+                      "Expecting the aux PHY to be transmitting (an RTS frame)");
+        Simulator::Schedule(stateHelper->GetDelayUntilIdle(),
+                            &EmlsrManager::SwitchMainPhy,
+                            this,
+                            linkId,
+                            true); // channel switch should occur instantaneously
+    }
+}
+
+void
+EmlsrManager::NotifyTxopEnd(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+
+    if (!m_staMac->IsEmlsrLink(linkId))
+    {
+        NS_LOG_DEBUG("EMLSR is not enabled on link " << +linkId);
+        return;
+    }
+
+    // unblock transmissions and resume medium access on other EMLSR links
+    for (auto id : m_staMac->GetLinkIds())
+    {
+        if (id != linkId && m_staMac->IsEmlsrLink(id))
+        {
+            m_staMac->UnblockTxOnLink(id, WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
+            m_staMac->GetChannelAccessManager(id)->NotifyStopUsingOtherEmlsrLink();
+        }
+    }
+}
+
+void
+EmlsrManager::SwitchMainPhy(uint8_t linkId, bool noSwitchDelay)
+{
+    NS_LOG_FUNCTION(this << linkId << noSwitchDelay);
+
+    auto mainPhy = m_staMac->GetDevice()->GetPhy(m_mainPhyId);
+
+    NS_ASSERT_MSG(mainPhy != m_staMac->GetWifiPhy(linkId),
+                  "Main PHY is already operating on link " << +linkId);
+
+    // find the link on which the main PHY is operating
+    auto currMainPhyLinkId = m_staMac->GetLinkForPhy(mainPhy);
+    NS_ASSERT_MSG(currMainPhyLinkId, "Current link ID for main PHY not found");
+
+    auto newMainPhyChannel = GetChannelForMainPhy(linkId);
+
+    NS_LOG_DEBUG("Main PHY (" << mainPhy << ") is about to switch to " << newMainPhyChannel
+                              << " to operate on link " << +linkId);
+
+    // notify the channel access manager of the upcoming channel switch(es)
+    m_staMac->GetChannelAccessManager(*currMainPhyLinkId)
+        ->NotifySwitchingEmlsrLink(mainPhy, newMainPhyChannel, linkId);
+
+    // this assert also ensures that the actual channel switch is not delayed
+    NS_ASSERT_MSG(!mainPhy->GetState()->IsStateTx(),
+                  "We should not ask the main PHY to switch channel while transmitting");
+
+    // request the main PHY to switch channel
+    Simulator::ScheduleNow([=]() {
+        auto delay = mainPhy->GetChannelSwitchDelay();
+        NS_ASSERT_MSG(noSwitchDelay || delay <= m_lastAdvTransitionDelay,
+                      "Transition delay (" << m_lastAdvTransitionDelay.As(Time::US)
+                                           << ") should exceed the channel switch delay ("
+                                           << delay.As(Time::US) << ")");
+        if (noSwitchDelay)
+        {
+            mainPhy->SetAttribute("ChannelSwitchDelay", TimeValue(Seconds(0)));
+        }
+        mainPhy->SetOperatingChannel(newMainPhyChannel);
+        // restore previous channel switch delay
+        if (noSwitchDelay)
+        {
+            mainPhy->SetAttribute("ChannelSwitchDelay", TimeValue(delay));
+        }
+    });
+
+    NotifyMainPhySwitch(*currMainPhyLinkId, linkId);
+}
 
-    MgtEmlOperatingModeNotification frame;
+MgtEmlOmn
+EmlsrManager::GetEmlOmn()
+{
+    MgtEmlOmn frame;
 
     // Add the EMLSR Parameter Update field if needed
     if (m_lastAdvPaddingDelay != m_emlsrPaddingDelay ||
@@ -205,7 +394,7 @@
         m_lastAdvPaddingDelay = m_emlsrPaddingDelay;
         m_lastAdvTransitionDelay = m_emlsrTransitionDelay;
         frame.m_emlControl.emlsrParamUpdateCtrl = 1;
-        frame.m_emlsrParamUpdate = MgtEmlOperatingModeNotification::EmlsrParamUpdate{};
+        frame.m_emlsrParamUpdate = MgtEmlOmn::EmlsrParamUpdate{};
         frame.m_emlsrParamUpdate->paddingDelay =
             CommonInfoBasicMle::EncodeEmlsrPaddingDelay(m_lastAdvPaddingDelay);
         frame.m_emlsrParamUpdate->transitionDelay =
@@ -220,9 +409,7 @@
         if (auto setupLinkIt = setupLinkIds.find(*emlsrLinkIt); setupLinkIt != setupLinkIds.cend())
         {
             setupLinkIds.erase(setupLinkIt);
-            auto apLinkId = m_staMac->GetApLinkId(*emlsrLinkIt);
-            NS_ASSERT(apLinkId);
-            frame.SetLinkIdInBitmap(*apLinkId);
+            frame.SetLinkIdInBitmap(*emlsrLinkIt);
             emlsrLinkIt++;
         }
         else
@@ -235,6 +422,18 @@
     // EMLSR Mode is enabled if and only if the set of EMLSR links is not empty
     frame.m_emlControl.emlsrMode = m_nextEmlsrLinks->empty() ? 0 : 1;
 
+    return frame;
+}
+
+void
+EmlsrManager::SendEmlOmn()
+{
+    NS_LOG_FUNCTION(this);
+
+    NS_ABORT_MSG_IF(!m_emlsrTransitionTimeout,
+                    "AP did not advertise a Transition Timeout, cannot send EML notification");
+    NS_ASSERT_MSG(m_nextEmlsrLinks, "Need to set EMLSR links before calling this method");
+
     // TODO if this is a single radio non-AP MLD and not all setup links are in the EMLSR link
     // set, we have to put setup links that are not included in the given EMLSR link set (i.e.,
     // those remaining in setupLinkIds, if m_nextEmlsrLinks is not empty) in the sleep mode:
@@ -244,8 +443,9 @@
     // non-AP STA affiliated with the non-AP MLD that operates on one of the EMLSR links is
     // in awake state. (Sec. 35.3.17 of 802.11be D3.0)
 
-    auto linkId = GetLinkToSendEmlNotification();
-    GetEhtFem(linkId)->SendEmlOperatingModeNotification(m_staMac->GetBssid(linkId), frame);
+    auto frame = GetEmlOmn();
+    auto linkId = GetLinkToSendEmlOmn();
+    GetEhtFem(linkId)->SendEmlOmn(m_staMac->GetBssid(linkId), frame);
 }
 
 void
@@ -303,10 +503,9 @@
             auto linkId = ResendNotification(mpdu);
             if (linkId)
             {
-                MgtEmlOperatingModeNotification frame;
+                MgtEmlOmn frame;
                 pkt->RemoveHeader(frame);
-                GetEhtFem(*linkId)->SendEmlOperatingModeNotification(m_staMac->GetBssid(*linkId),
-                                                                     frame);
+                GetEhtFem(*linkId)->SendEmlOmn(m_staMac->GetBssid(*linkId), frame);
             }
             else
             {
@@ -332,10 +531,108 @@
     m_emlsrLinks.swap(*m_nextEmlsrLinks);
     m_nextEmlsrLinks.reset();
 
-    // TODO Make other non-AP STAs operating on the corresponding EMLSR links transition to
+    // Make other non-AP STAs operating on the corresponding EMLSR links transition to
     // active mode or passive mode (depending on whether EMLSR mode has been enabled or disabled)
+    m_staMac->NotifyEmlsrModeChanged(m_emlsrLinks);
+    // Enforce the limit on the max channel width supported by aux PHYs
+    ApplyMaxChannelWidthOnAuxPhys();
 
     NotifyEmlsrModeChanged();
 }
 
+void
+EmlsrManager::ApplyMaxChannelWidthOnAuxPhys()
+{
+    NS_LOG_FUNCTION(this);
+    auto currMainPhyLinkId = m_staMac->GetLinkForPhy(m_mainPhyId);
+    NS_ASSERT(currMainPhyLinkId);
+
+    for (const auto linkId : m_staMac->GetLinkIds())
+    {
+        auto auxPhy = m_staMac->GetWifiPhy(linkId);
+        auto channel = GetChannelForAuxPhy(linkId);
+
+        if (linkId == currMainPhyLinkId || !m_staMac->IsEmlsrLink(linkId) ||
+            auxPhy->GetOperatingChannel() == channel)
+        {
+            continue;
+        }
+
+        NS_LOG_DEBUG("Aux PHY (" << auxPhy << ") is about to switch to " << channel
+                                 << " to operate on link " << +linkId);
+        // We cannot simply set the new channel, because otherwise the MAC will disable
+        // the setup link. We need to inform the MAC (via the Channel Access Manager) that
+        // this channel switch must not have such a consequence. We already have a method
+        // for doing so, i.e., inform the MAC that the PHY is switching channel to operate
+        // on the "same" link.
+        m_staMac->GetChannelAccessManager(linkId)->NotifySwitchingEmlsrLink(auxPhy,
+                                                                            channel,
+                                                                            linkId);
+
+        void (WifiPhy::*fp)(const WifiPhyOperatingChannel&) = &WifiPhy::SetOperatingChannel;
+        Simulator::ScheduleNow(fp, auxPhy, channel);
+    }
+}
+
+void
+EmlsrManager::ComputeOperatingChannels()
+{
+    NS_LOG_FUNCTION(this);
+
+    m_mainPhyChannels.clear();
+    m_auxPhyChannels.clear();
+
+    auto linkIds = m_staMac->GetSetupLinkIds();
+
+    for (auto linkId : linkIds)
+    {
+        const auto& channel = m_staMac->GetWifiPhy(linkId)->GetOperatingChannel();
+        m_mainPhyChannels.emplace(linkId, channel);
+
+        auto mainPhyChWidth = channel.GetWidth();
+        if (m_auxPhyMaxWidth >= mainPhyChWidth)
+        {
+            // same channel can be used by aux PHYs
+            m_auxPhyChannels.emplace(linkId, channel);
+            continue;
+        }
+        // aux PHYs will operate on a primary subchannel
+        auto freq = channel.GetPrimaryChannelCenterFrequency(m_auxPhyMaxWidth);
+        auto chIt = WifiPhyOperatingChannel::FindFirst(0,
+                                                       freq,
+                                                       m_auxPhyMaxWidth,
+                                                       WIFI_STANDARD_UNSPECIFIED,
+                                                       channel.GetPhyBand());
+        NS_ASSERT_MSG(chIt != WifiPhyOperatingChannel::m_frequencyChannels.end(),
+                      "Primary" << m_auxPhyMaxWidth << " channel not found");
+        m_auxPhyChannels.emplace(linkId, chIt);
+        // find the P20 index for the channel used by the aux PHYs
+        auto p20Index = channel.GetPrimaryChannelIndex(20);
+        while (mainPhyChWidth > m_auxPhyMaxWidth)
+        {
+            mainPhyChWidth /= 2;
+            p20Index /= 2;
+        }
+        m_auxPhyChannels[linkId].SetPrimary20Index(p20Index);
+    }
+}
+
+const WifiPhyOperatingChannel&
+EmlsrManager::GetChannelForMainPhy(uint8_t linkId) const
+{
+    auto it = m_mainPhyChannels.find(linkId);
+    NS_ASSERT_MSG(it != m_mainPhyChannels.end(),
+                  "Channel for main PHY on link ID " << +linkId << " not found");
+    return it->second;
+}
+
+const WifiPhyOperatingChannel&
+EmlsrManager::GetChannelForAuxPhy(uint8_t linkId) const
+{
+    auto it = m_auxPhyChannels.find(linkId);
+    NS_ASSERT_MSG(it != m_auxPhyChannels.end(),
+                  "Channel for aux PHY on link ID " << +linkId << " not found");
+    return it->second;
+}
+
 } // namespace ns3
